Categories
Core

WordPress Core Support Policy

When it comes to policies regarding support for previous releases of a project’s dependencies, it is important to strike a fair balance between progress and stability. As we look to increase the performance and reliability of WooCommerce, it is necessary that we clearly outline exactly what that policy is, as well as our goals in creating it.

Starting with the 4.2 release, we will adapt an L-2 sliding window support policy.

What this means is that we are committed to ensuring that WooCommerce Core will work with the current WordPress version, as well as the latest release from the two previous release branches.

As an example, when WooCommerce 4.2 is released, it will officially support:

  • WordPress 5.4.1 (the most recent version of WordPress),
  • WordPress 5.3.3, and
  • WordPress 5.2.6 (from the two previous release branches).

We’d like to outline the three major factors that played a role in this decision, so that everyone can better understand the context behind it.

Testing Surface

Over the last year our top priority has been stability. This does not come without a cost, and a great deal of work has gone into thoroughly testing every release. In order for us to be as confident as possible in shipping, we need to make sure that WooCommerce works on every version of WordPress that we support.

If we try to support too many versions at once either the quality of the testing or the frequency of the releases will suffer. As we view neither of these to be an acceptable loss, we need to adopt a predictable support policy.

Security & Fixes

Given the kind of platform WooCommerce is, there is an increased scrutiny in ensuring that shops are secure and stable. The hope is that by more aggressively encouraging users to update, we avoid enabling stragglers that may be unknowingly leaving their shops open to attack.

Features & Enhancements

Each successive release of WordPress Core carries with it new features and enhancements that enable us to deliver the best experience to merchants. While in many cases we can use progressive enhancement to enable features in specific versions, the larger the minimum version margin becomes, the more significant the maintenance burden. We feel that this sliding window is large enough to be maintainable while still enabling us to take advantage of the new features.

We hope that you’ll join us in moving forward with the WordPress platform, and in helping keep all sites running WooCommerce up to date with the latest, greatest, most secure software available.

2 replies on “WordPress Core Support Policy”

Any chance this faster release cycle will bring with it a semblance of semantic versioning?

It’s hard enough testing updates on a slower release cycle, and we all know the commonplace horror stories.

But the idea of needing to do this monthly because security and bug fixes are being bundled with new features and other potentially breaking changes (compounded by the hugh library of extensions), seems like a recipe for disaster!

Like

We’re actually following semantic versioning already! None of our minor releases have featured any breaking changes in quite some time; even 4.0 didn’t feature any notable breaking changes.

With respect to the WC Tested header, we’ve got something in the pipeline that should make it easier for extension developers. We’re going to support declaring support for major versions without needing to release a new version every month alongside Core.

Liked by 2 people

Comments are closed.